//  Mouse PS/2 for Amiga & Atari ST
//  PS/2 Protocol  =  Arduino Community
//
//  (c) 6502MAN

#include "ps2.h"



// PS2 mouse(clock pin, data pin)  //
PS2 mouse(11, 10); // connecteur PS/2 sur Arduino


#define Bouton1Pin 13 // Bouton1
#define Bouton2Pin 12 // Bouton2
#define XaPin 6 // Xa
#define YaPin 7 // Ya
#define YbPin 8 // Yb
#define XbPin 9 // Xb


char MouseID=0,MSmode=0;




/*
 * initialize the mouse. Reset it, and place it into remote
 * mode, so we can get the encoder data on demand.
 */
void mouse_init()
{
  int STATUSPS2=0;

  mouse.write(0xff);  // reset
  STATUSPS2=mouse.read();        // ack
  mouse.read();  // blank
  mouse.read();  // blank
  mouse.write(0xf0);  // remote mode
  STATUSPS2=mouse.read();        // ack
  
  
 //------------------------------
 //  ajout 6502MAN
  mouse.write(0xeb);   // demande datas
  mouse.read();        // ignore ack
  mouse.read() ; // ignore  boutons
  mouse.read();        // ignore X
  mouse.read();        // ignore Y
   
  mouse.write(0xf3);   // Set sample rate
    STATUSPS2=mouse.read();        // ack
  mouse.write(200);    // Max sample rate
    STATUSPS2=mouse.read();        // ack

 //-------------------------------
 //  interroge le mode 3 si compatible
  mouse.write(0xf3);   // Set sample rate
  mouse.read();        // ack
  mouse.write(100);
  mouse.read();        // ack  

  mouse.write(0xf3);   // Set sample rate
  mouse.read();        // ack
  mouse.write(80);
  mouse.read();        // ack  
//-------------------------------

  mouse.write(0xf2);   // Get device ID
  mouse.read();        // ack
  MouseID = mouse.read();   // Mouse ID
  

  mouse.write(0xf3);   // Set sample rate
  mouse.read();        // ack
  mouse.write(200);    // Max sample rate
  mouse.read();        // ack  
  
  mouse.write(0xe8);   // Set Resolution
  mouse.read();        // ack
  mouse.write(3);      // 8 counts/mm
  mouse.read();        // ack  

 //------------------------------
  delayMicroseconds(100);
  
  

  mouse.write(0xeb);   // commande "demande datas"
  mouse.read();        // ignore ack
  MSmode = mouse.read() & 2 ; // lit l'etat du bouton droit

if (MouseID) { mouse.read(); }
	 

  // ---   INIT PIN 
  pinMode(Bouton1Pin,OUTPUT);
  pinMode(Bouton2Pin,OUTPUT);
  pinMode(XaPin,OUTPUT);
  pinMode(XbPin,OUTPUT);
  pinMode(YaPin,OUTPUT);
  pinMode(YbPin,OUTPUT);
  
	digitalWrite(Bouton1Pin,HIGH);
	digitalWrite(Bouton2Pin,HIGH);
	digitalWrite(XaPin,HIGH);
	digitalWrite(XbPin,HIGH);
	digitalWrite(YaPin,HIGH);
	digitalWrite(YbPin,HIGH); 
}






void setup()
{
  mouse_init();
}




/*
 * EMULATION Amiga & Atari ST
 */
void loop()
{
  char mstat;
  char mx;
  char my;
  char mz;
  int Bouton=0;
  int TimingX=3000;
  int TimingY=3000;
  
	int RepetX=0;
	int RepetY=0;
	int SensX=0;
	int SensY=0;
	int BouclXY=0;
  
  /* recupére les données de la souris PS/2 */
  mouse.write(0xeb);  // envoi data!
  mouse.read();      // ignore ack
  //delay(10);
  mstat = mouse.read();  // boutons + overflow X Y
  mx = mouse.read();	//	deplacement X
  my = mouse.read();	//	deplacement Y
  if (MouseID) mz = mouse.read();		//	si type >0 alors lire 4eme octets
  Bouton=mstat & 7;		//	recupere l'etat des 3 boutons.
  
 
//	si bouton 1 est appuye alors envoi l'info au TO8
  if(Bouton&1) {digitalWrite(Bouton1Pin,LOW);} else {digitalWrite(Bouton1Pin,HIGH);}

//	si bouton 2 est appuye alors envoi l'info au TO8  
  if(Bouton&2) { digitalWrite(Bouton2Pin,LOW); } else {digitalWrite(Bouton2Pin,HIGH);}
 
// si il y a un deplacement ou un bouton appuye alors on affiche les donnees et ont
// et on envoi l'info au TO8   sinon rien.
  if ( (mx==0) & (my==0)& (mz==0) )
   {
   }
  else
  {
	TimingX=TimingX-abs(mx/4);
	TimingY=TimingY-abs(my/4);

	if (mx!=0) {RepetX=1+abs(mx/10);}
	if (my!=0) {RepetY=1+abs(my/10);}
	if (mx>0)	{ SensX=1;} else {SensX=0; }
	if (my>0)	{ SensY=1;} else {SensY=0; }

	if (RepetX>RepetY) {BouclXY=RepetX;} else {BouclXY=RepetY;}
	
	
/*	
	principe de fonctionnement de la souris :
	Envoie de NN cycles de = Xa,[delai],Xb,[delai],Ya,[delai],Yb,[delai]
		NN = nombre de fois que les donnees sont envoye proportionnel à la vitesse de deplacement de la souris.
		[delai] = temps d'attente entre 2 pulses.
	déplacements positifs Xa puis Xb  ou  Ya puis Yb
	déplacements negatifs Xb puis Xa  ou  Yb puis Ya
	boucle d'envoi des pulses egale au plus grand deplacement X ou Y 
*/	
	int i=0;
	while( i<=BouclXY)
	{
		if (RepetX>0)
		{
		if (SensX==1)
		{
		digitalWrite(XaPin,LOW);
				delayMicroseconds(TimingX);
		digitalWrite(XbPin,LOW);
				delayMicroseconds(TimingX);
			digitalWrite(XaPin,HIGH);
				delayMicroseconds(TimingX);
			digitalWrite(XbPin,HIGH);
				delayMicroseconds(TimingX);
        }
		else
        {
		digitalWrite(XbPin,LOW);
				delayMicroseconds(TimingX);
		digitalWrite(XaPin,LOW);
				delayMicroseconds(TimingX);
			digitalWrite(XbPin,HIGH);
				delayMicroseconds(TimingX);
			digitalWrite(XaPin,HIGH);
       delayMicroseconds(TimingX);
        }
		RepetX--;
		}
		
		
		if (RepetY>0)
		{
		if (SensY==0)
            {
		digitalWrite(YaPin,LOW);
				delayMicroseconds(TimingY);
		digitalWrite(YbPin,LOW);
				delayMicroseconds(TimingY);
			digitalWrite(YaPin,HIGH);
				delayMicroseconds(TimingY);
			digitalWrite(YbPin,HIGH);
                                delayMicroseconds(TimingY);	
            }
		else
          {
		digitalWrite(YbPin,LOW);
				delayMicroseconds(TimingY);
		digitalWrite(YaPin,LOW);
				delayMicroseconds(TimingY);
			digitalWrite(YbPin,HIGH);
				delayMicroseconds(TimingY);
			digitalWrite(YaPin,HIGH);
                                delayMicroseconds(TimingY);	
          }
		RepetY--;
		}		
		
		
		i++;
	}

  }

}
